Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Core.cs	(revision 6725)
@@ -50,5 +50,5 @@
     private ServiceHost slaveComm;
     private WcfService wcfService;
-    private JobManager jobManager;
+    private TaskManager taskManager;
     private ConfigManager configManager;
     private PluginManager pluginManager;
@@ -57,10 +57,10 @@
       var log = new ThreadSafeLog(new Log(Settings.Default.MaxLogCount));
       this.pluginManager = new PluginManager(WcfService.Instance, log);
-      this.jobManager = new JobManager(pluginManager, log);
+      this.taskManager = new TaskManager(pluginManager, log);
       log.MessageAdded += new EventHandler<EventArgs<string>>(log_MessageAdded);
 
-      RegisterJobManagerEvents();
-
-      this.configManager = new ConfigManager(jobManager);
+      RegisterTaskManagerEvents();
+
+      this.configManager = new ConfigManager(taskManager);
       ConfigManager.Instance = this.configManager;
     }
@@ -78,5 +78,5 @@
         clientCom = SlaveClientCom.Instance.ClientCom;
 
-        // delete all left over job directories
+        // delete all left over task directories
         pluginManager.CleanPluginTemp();
         clientCom.LogMessage("Hive Slave started");
@@ -149,5 +149,5 @@
     /// <param name="container">The container, containing the message</param>
     private void DetermineAction(MessageContainer container) {
-      clientCom.LogMessage(string.Format("Message: {0} for job: {1} ", container.Message.ToString(), container.TaskId));
+      clientCom.LogMessage(string.Format("Message: {0} for task: {1} ", container.Message.ToString(), container.TaskId));
 
       if (container is ExecutorMessageContainer<Guid>) {
@@ -156,15 +156,15 @@
       } else if (container is MessageContainer) {
         switch (container.Message) {
-          case MessageContainer.MessageType.CalculateJob:
-            CalculateJobAsync(container.TaskId);
-            break;
-          case MessageContainer.MessageType.AbortJob:
-            AbortJobAsync(container.TaskId);
-            break;
-          case MessageContainer.MessageType.StopJob:
-            StopJobAsync(container.TaskId);
-            break;
-          case MessageContainer.MessageType.PauseJob:
-            PauseJobAsync(container.TaskId);
+          case MessageContainer.MessageType.CalculateTask:
+            CalculateTaskAsync(container.TaskId);
+            break;
+          case MessageContainer.MessageType.AbortTask:
+            AbortTaskAsync(container.TaskId);
+            break;
+          case MessageContainer.MessageType.StopTask:
+            StopTaskAsync(container.TaskId);
+            break;
+          case MessageContainer.MessageType.PauseTask:
+            PauseTaskAsync(container.TaskId);
             break;
           case MessageContainer.MessageType.StopAll:
@@ -195,6 +195,6 @@
     }
 
-    private void CalculateJobAsync(Guid jobId) {
-      TS.Task.Factory.StartNew(HandleCalculateJob, jobId)
+    private void CalculateTaskAsync(Guid jobId) {
+      TS.Task.Factory.StartNew(HandleCalculateTask, jobId)
       .ContinueWith((t) => {
         SlaveStatusInfo.IncrementExceptionOccured();
@@ -203,6 +203,6 @@
     }
 
-    private void StopJobAsync(Guid jobId) {
-      TS.Task.Factory.StartNew(HandleStopJob, jobId)
+    private void StopTaskAsync(Guid jobId) {
+      TS.Task.Factory.StartNew(HandleStopTask, jobId)
        .ContinueWith((t) => {
          SlaveStatusInfo.IncrementExceptionOccured();
@@ -211,6 +211,6 @@
     }
 
-    private void PauseJobAsync(Guid jobId) {
-      TS.Task.Factory.StartNew(HandlePauseJob, jobId)
+    private void PauseTaskAsync(Guid jobId) {
+      TS.Task.Factory.StartNew(HandlePauseTask, jobId)
        .ContinueWith((t) => {
          SlaveStatusInfo.IncrementExceptionOccured();
@@ -219,6 +219,6 @@
     }
 
-    private void AbortJobAsync(Guid jobId) {
-      TS.Task.Factory.StartNew(HandleAbortJob, jobId)
+    private void AbortTaskAsync(Guid jobId) {
+      TS.Task.Factory.StartNew(HandleAbortTask, jobId)
        .ContinueWith((t) => {
          SlaveStatusInfo.IncrementExceptionOccured();
@@ -227,58 +227,58 @@
     }
 
-    private void HandleCalculateJob(object jobIdObj) {
-      Guid jobId = (Guid)jobIdObj;
-      Task job = null;
+    private void HandleCalculateTask(object taskIdObj) {
+      Guid taskId = (Guid)taskIdObj;
+      Task task = null;
       int usedCores = 0;
       try {
-        job = wcfService.GetJob(jobId);
-        if (job == null) throw new JobNotFoundException(jobId);
-        if (ConfigManager.Instance.GetFreeCores() < job.CoresNeeded) throw new OutOfCoresException();
-        if (ConfigManager.GetFreeMemory() < job.MemoryNeeded) throw new OutOfMemoryException();
-        SlaveStatusInfo.IncrementUsedCores(job.CoresNeeded); usedCores = job.CoresNeeded;
-        TaskData jobData = wcfService.GetJobData(jobId);
-        if (jobData == null) throw new JobDataNotFoundException(jobId);
-        job = wcfService.UpdateJobState(jobId, TaskState.Calculating, null);
-        if (job == null) throw new JobNotFoundException(jobId);
-        jobManager.StartJobAsync(job, jobData);
-      }
-      catch (JobNotFoundException) {
+        task = wcfService.GetJob(taskId);
+        if (task == null) throw new TaskNotFoundException(taskId);
+        if (ConfigManager.Instance.GetFreeCores() < task.CoresNeeded) throw new OutOfCoresException();
+        if (ConfigManager.GetFreeMemory() < task.MemoryNeeded) throw new OutOfMemoryException();
+        SlaveStatusInfo.IncrementUsedCores(task.CoresNeeded); usedCores = task.CoresNeeded;
+        TaskData taskData = wcfService.GetJobData(taskId);
+        if (taskData == null) throw new TaskDataNotFoundException(taskId);
+        task = wcfService.UpdateJobState(taskId, TaskState.Calculating, null);
+        if (task == null) throw new TaskNotFoundException(taskId);
+        taskManager.StartTaskAsync(task, taskData);
+      }
+      catch (TaskNotFoundException) {
         SlaveStatusInfo.DecrementUsedCores(usedCores);
         throw;
       }
-      catch (JobDataNotFoundException) {
+      catch (TaskDataNotFoundException) {
         SlaveStatusInfo.DecrementUsedCores(usedCores);
         throw;
       }
-      catch (JobAlreadyRunningException) {
+      catch (TaskAlreadyRunningException) {
         SlaveStatusInfo.DecrementUsedCores(usedCores);
         throw;
       }
       catch (OutOfCoresException) {
-        wcfService.UpdateJobState(jobId, TaskState.Waiting, "No more cores available");
+        wcfService.UpdateJobState(taskId, TaskState.Waiting, "No more cores available");
         throw;
       }
       catch (OutOfMemoryException) {
-        wcfService.UpdateJobState(jobId, TaskState.Waiting, "No more memory available");
+        wcfService.UpdateJobState(taskId, TaskState.Waiting, "No more memory available");
         throw;
       }
       catch (Exception e) {
         SlaveStatusInfo.DecrementUsedCores(usedCores);
-        wcfService.UpdateJobState(jobId, TaskState.Waiting, e.ToString()); // unknown internal error - report and set waiting again
-        throw;
-      }
-    }
-
-    private void HandleStopJob(object jobIdObj) {
-      Guid jobId = (Guid)jobIdObj;
-      try {
-        Task job = wcfService.GetJob(jobId);
-        if (job == null) throw new JobNotFoundException(jobId);
-        jobManager.StopJobAsync(jobId);
-      }
-      catch (JobNotFoundException) {
-        throw;
-      }
-      catch (JobNotRunningException) {
+        wcfService.UpdateJobState(taskId, TaskState.Waiting, e.ToString()); // unknown internal error - report and set waiting again
+        throw;
+      }
+    }
+
+    private void HandleStopTask(object taskIdObj) {
+      Guid taskId = (Guid)taskIdObj;
+      try {
+        Task task = wcfService.GetJob(taskId);
+        if (task == null) throw new TaskNotFoundException(taskId);
+        taskManager.StopTaskAsync(taskId);
+      }
+      catch (TaskNotFoundException) {
+        throw;
+      }
+      catch (TaskNotRunningException) {
         throw;
       }
@@ -288,15 +288,15 @@
     }
 
-    private void HandlePauseJob(object jobIdObj) {
-      Guid jobId = (Guid)jobIdObj;
-      try {
-        Task job = wcfService.GetJob(jobId);
-        if (job == null) throw new JobNotFoundException(jobId);
-        jobManager.PauseJobAsync(jobId);
-      }
-      catch (JobNotFoundException) {
-        throw;
-      }
-      catch (JobNotRunningException) {
+    private void HandlePauseTask(object taskIdObj) {
+      Guid taskId = (Guid)taskIdObj;
+      try {
+        Task task = wcfService.GetJob(taskId);
+        if (task == null) throw new TaskNotFoundException(taskId);
+        taskManager.PauseTaskAsync(taskId);
+      }
+      catch (TaskNotFoundException) {
+        throw;
+      }
+      catch (TaskNotRunningException) {
         throw;
       }
@@ -306,39 +306,39 @@
     }
 
-    private void HandleAbortJob(object jobIdObj) {
-      Guid jobId = (Guid)jobIdObj;
-      try {
-        jobManager.AbortJob(jobId);
-      }
-      catch (JobNotFoundException) {
-        throw;
-      }
-    }
-
-    #region JobManager Events
-    private void RegisterJobManagerEvents() {
-      this.jobManager.JobStarted += new EventHandler<EventArgs<SlaveJob>>(jobManager_JobStarted);
-      this.jobManager.JobPaused += new EventHandler<EventArgs<SlaveJob, TaskData>>(jobManager_JobPaused);
-      this.jobManager.JobStopped += new EventHandler<EventArgs<SlaveJob, TaskData>>(jobManager_JobStopped);
-      this.jobManager.JobFailed += new EventHandler<EventArgs<Tuple<SlaveJob, TaskData, Exception>>>(jobManager_JobFailed);
-      this.jobManager.ExceptionOccured += new EventHandler<EventArgs<SlaveJob, Exception>>(jobManager_ExceptionOccured);
-      this.jobManager.JobAborted += new EventHandler<EventArgs<SlaveJob>>(jobManager_JobAborted);
-    }
-
-    private void jobManager_JobStarted(object sender, EventArgs<SlaveJob> e) {
+    private void HandleAbortTask(object taskIdObj) {
+      Guid taskId = (Guid)taskIdObj;
+      try {
+        taskManager.AbortTask(taskId);
+      }
+      catch (TaskNotFoundException) {
+        throw;
+      }
+    }
+
+    #region TaskManager Events
+    private void RegisterTaskManagerEvents() {
+      this.taskManager.TaskStarted += new EventHandler<EventArgs<SlaveTask>>(taskManager_TaskStarted);
+      this.taskManager.TaskPaused += new EventHandler<EventArgs<SlaveTask, TaskData>>(taskManager_TaskPaused);
+      this.taskManager.TaskStopped += new EventHandler<EventArgs<SlaveTask, TaskData>>(taskManager_TaskStopped);
+      this.taskManager.TaskFailed += new EventHandler<EventArgs<Tuple<SlaveTask, TaskData, Exception>>>(taskManager_TaskFailed);
+      this.taskManager.ExceptionOccured += new EventHandler<EventArgs<SlaveTask, Exception>>(taskManager_ExceptionOccured);
+      this.taskManager.TaskAborted += new EventHandler<EventArgs<SlaveTask>>(taskManager_TaskAborted);
+    }
+
+    private void taskManager_TaskStarted(object sender, EventArgs<SlaveTask> e) {
       // successfully started, everything is good
     }
 
-    private void jobManager_JobPaused(object sender, EventArgs<SlaveJob, TaskData> e) {
+    private void taskManager_TaskPaused(object sender, EventArgs<SlaveTask, TaskData> e) {
       try {
         SlaveStatusInfo.DecrementUsedCores(e.Value.CoresNeeded);
         heartbeatManager.AwakeHeartBeatThread();
-        Task job = wcfService.GetJob(e.Value.JobId);
-        if (job == null) throw new JobNotFoundException(e.Value.JobId);
-        job.ExecutionTime = e.Value.ExecutionTime;
-        TaskData jobData = e.Value.GetJobData();
-        wcfService.UpdateJobData(job, jobData, configManager.GetClientInfo().Id, TaskState.Paused);
-      }
-      catch (JobNotFoundException ex) {
+        Task task = wcfService.GetJob(e.Value.TaskId);
+        if (task == null) throw new TaskNotFoundException(e.Value.TaskId);
+        task.ExecutionTime = e.Value.ExecutionTime;
+        TaskData taskData = e.Value.GetTaskData();
+        wcfService.UpdateJobData(task, taskData, configManager.GetClientInfo().Id, TaskState.Paused);
+      }
+      catch (TaskNotFoundException ex) {
         clientCom.LogMessage(ex.ToString());
       }
@@ -348,15 +348,15 @@
     }
 
-    private void jobManager_JobStopped(object sender, EventArgs<SlaveJob, TaskData> e) {
+    private void taskManager_TaskStopped(object sender, EventArgs<SlaveTask, TaskData> e) {
       try {
         SlaveStatusInfo.DecrementUsedCores(e.Value.CoresNeeded);
         heartbeatManager.AwakeHeartBeatThread();
-        Task job = wcfService.GetJob(e.Value.JobId);
-        if (job == null) throw new JobNotFoundException(e.Value.JobId);
-        job.ExecutionTime = e.Value.ExecutionTime;
-        TaskData jobData = e.Value.GetJobData();
-        wcfService.UpdateJobData(job, jobData, configManager.GetClientInfo().Id, TaskState.Finished);
-      }
-      catch (JobNotFoundException ex) {
+        Task task = wcfService.GetJob(e.Value.TaskId);
+        if (task == null) throw new TaskNotFoundException(e.Value.TaskId);
+        task.ExecutionTime = e.Value.ExecutionTime;
+        TaskData taskData = e.Value.GetTaskData();
+        wcfService.UpdateJobData(task, taskData, configManager.GetClientInfo().Id, TaskState.Finished);
+      }
+      catch (TaskNotFoundException ex) {
         clientCom.LogMessage(ex.ToString());
       }
@@ -366,23 +366,23 @@
     }
 
-    private void jobManager_JobFailed(object sender, EventArgs<Tuple<SlaveJob, TaskData, Exception>> e) {
+    private void taskManager_TaskFailed(object sender, EventArgs<Tuple<SlaveTask, TaskData, Exception>> e) {
       try {
         SlaveStatusInfo.DecrementUsedCores(e.Value.Item1.CoresNeeded);
         heartbeatManager.AwakeHeartBeatThread();
-        SlaveJob slaveJob = e.Value.Item1;
-        TaskData jobData = e.Value.Item2;
+        SlaveTask slaveTask = e.Value.Item1;
+        TaskData taskData = e.Value.Item2;
         Exception exception = e.Value.Item3;
 
-        Task job = wcfService.GetJob(slaveJob.JobId);
-        if (job == null) throw new JobNotFoundException(slaveJob.JobId);
-        job.ExecutionTime = slaveJob.ExecutionTime;
-        if (jobData != null) {
-          wcfService.UpdateJobData(job, jobData, configManager.GetClientInfo().Id, TaskState.Failed, exception.ToString());
+        Task task = wcfService.GetJob(slaveTask.TaskId);
+        if (task == null) throw new TaskNotFoundException(slaveTask.TaskId);
+        task.ExecutionTime = slaveTask.ExecutionTime;
+        if (taskData != null) {
+          wcfService.UpdateJobData(task, taskData, configManager.GetClientInfo().Id, TaskState.Failed, exception.ToString());
         } else {
-          wcfService.UpdateJobState(job.Id, TaskState.Failed, exception.ToString());
+          wcfService.UpdateJobState(task.Id, TaskState.Failed, exception.ToString());
         }
         clientCom.LogMessage(exception.Message);
       }
-      catch (JobNotFoundException ex) {
+      catch (TaskNotFoundException ex) {
         SlaveStatusInfo.IncrementExceptionOccured();
         clientCom.LogMessage(ex.ToString());
@@ -394,13 +394,13 @@
     }
 
-    private void jobManager_ExceptionOccured(object sender, EventArgs<SlaveJob, Exception> e) {
+    private void taskManager_ExceptionOccured(object sender, EventArgs<SlaveTask, Exception> e) {
       SlaveStatusInfo.DecrementUsedCores(e.Value.CoresNeeded);
       SlaveStatusInfo.IncrementExceptionOccured();
       heartbeatManager.AwakeHeartBeatThread();
-      clientCom.LogMessage(string.Format("Exception occured for job {0}: {1}", e.Value.JobId, e.Value2.ToString()));
-      wcfService.UpdateJobState(e.Value.JobId, TaskState.Waiting, e.Value2.ToString());
-    }
-
-    private void jobManager_JobAborted(object sender, EventArgs<SlaveJob> e) {
+      clientCom.LogMessage(string.Format("Exception occured for task {0}: {1}", e.Value.TaskId, e.Value2.ToString()));
+      wcfService.UpdateJobState(e.Value.TaskId, TaskState.Waiting, e.Value2.ToString());
+    }
+
+    private void taskManager_TaskAborted(object sender, EventArgs<SlaveTask> e) {
       SlaveStatusInfo.DecrementUsedCores(e.Value.CoresNeeded);
     }
@@ -418,6 +418,6 @@
     private void DoAbortAll() {
       clientCom.LogMessage("Aborting all jobs.");
-      foreach (Guid jobId in jobManager.JobIds) {
-        AbortJobAsync(jobId);
+      foreach (Guid taskId in taskManager.TaskIds) {
+        AbortTaskAsync(taskId);
       }
     }
@@ -428,6 +428,6 @@
     private void DoPauseAll() {
       clientCom.LogMessage("Pausing all jobs.");
-      foreach (Guid jobId in jobManager.JobIds) {
-        PauseJobAsync(jobId);
+      foreach (Guid taskId in taskManager.TaskIds) {
+        PauseTaskAsync(taskId);
       }
     }
@@ -438,6 +438,6 @@
     private void DoStopAll() {
       clientCom.LogMessage("Stopping all jobs.");
-      foreach (Guid jobId in jobManager.JobIds) {
-        StopJobAsync(jobId);
+      foreach (Guid taskId in taskManager.TaskIds) {
+        StopTaskAsync(taskId);
       }
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/AppDomainNotCreatedException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/AppDomainNotCreatedException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/AppDomainNotCreatedException.cs	(revision 6725)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+  public class AppDomainNotCreatedException : Exception {
+    public AppDomainNotCreatedException() : base("AppDomain has not been created.") { }
+  }
+}
+
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/SerializationException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/SerializationException.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/SerializationException.cs	(revision 6725)
@@ -24,5 +24,5 @@
 namespace HeuristicLab.Clients.Hive.SlaveCore {
   public class SerializationException : Exception {
-    public SerializationException() : base("Serializing job failed.") { }
+    public SerializationException() : base("Serializing task failed.") { }
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskAlreadyRunningException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskAlreadyRunningException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskAlreadyRunningException.cs	(revision 6725)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+  public class TaskAlreadyRunningException : Exception {
+    public TaskAlreadyRunningException(Guid jobId) : base(string.Format("Task with Id {0} is already running.", jobId)) { }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskFailedException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskFailedException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskFailedException.cs	(revision 6725)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+  public class TaskFailedException : Exception {
+    public TaskFailedException(string reason) : base(string.Format("Task failed with reason: {0}", reason)) { }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotDataFoundException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotDataFoundException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotDataFoundException.cs	(revision 6725)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+  public class TaskDataNotFoundException : Exception {
+    public TaskDataNotFoundException(Guid jobId) : base(string.Format("TaskData with TaskId {0} was not found on server.", jobId)) { }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotFoundException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotFoundException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotFoundException.cs	(revision 6725)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+  public class TaskNotFoundException : Exception {
+    public TaskNotFoundException(Guid jobId) : base (string.Format("Task with Id {0} was not found on server.", jobId)) { }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotRunningException.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotRunningException.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/Exceptions/TaskNotRunningException.cs	(revision 6725)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+  public class TaskNotRunningException : Exception {
+    public TaskNotRunningException(Guid jobId) : base(string.Format("Task with Id {0} is not running.", jobId)) { }
+  }
+}
